import "Turbine.UI";
import "Turbine.UI.Lotro";

import "PaulinoPlugins.PetCarousel";
import "PaulinoPlugins.PetCarousel.Lib.Turbine.UI.Extensions";

edgePadding = 50;

function LoadSettings()

settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "PetCarouselSettings" );

	if ( type( settings ) ~= "table" ) then
		settings = { };
	end
	
	if ( not settings.welcome ) then
		settings.welcome = false;
	end

	if ( not settings.positionX ) then		
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
	end
	
	if ( not settings.positionY ) then	
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
	end
	
	if ( not settings.alwaysHide ) then
		settings.alwaysHide = false;
	end
	
	if ( not settings.activeCarousel ) then
		settings.activeCarousel = 0;
	end
	
	if ( not settings.petQS1 ) then
		settings.petQS1 = 0;
	end
	
	if ( not settings.petQS2 ) then
		settings.petQS2 = 1;
	end
	
	if ( not settings.petQS3 ) then
		settings.petQS3 = 2;
	end

	if ( not settings.cosmeticQS1 ) then
		settings.cosmeticQS1 = 0;
	end
	
	if ( not settings.cosmeticQS2 ) then
		settings.cosmeticQS2 = 1;
	end
	
	if ( not settings.cosmeticQS3 ) then
		settings.cosmeticQS3 = 2;
	end

	if ( not settings.customShortcuts ) then
		settings.customShortcuts = { };
		
		--[[Change "11" for whatever you want to set the maximum number of Custom Shortcuts 
		(you will need to delete the Settings file located at Documents\The Lord of the Rings Online\PluginData\AccountName\ServerName\CharacterName\PetCarouselSettings.plugindata
		and reload the plugin)]]
		
		for i = 0, 11 do 
			settings.customShortcuts[i] = { Type = "nil", Data = "" };
		end
	end
	
	if ( not settings.customQS1 ) then
		settings.customQS1 = 0;
	end
	
	if ( not settings.customQS2 ) then
		settings.customQS2 = 1;
	end
	
	if ( not settings.customQS3 ) then
		settings.customQS3 = 2;
	end
	
end

function SaveSettings()

	Turbine.PluginData.Save( Turbine.DataScope.Character, "PetCarouselSettings", settings );

end

function TableCount(T)

	local count = 0
	for _ in pairs(T) do 
		count = count + 1 
	end
	return count

end

--Old mainWindow
--[[mainWindow = Turbine.UI.Lotro.Window();]]

mainWindow = Turbine.UI.Extensions.Window();
mainWindow:SetSize( 200 , 35 );
mainWindow:SetText("Pet Carousel");
mainWindow:SetOpacity( 0 );
mainWindow:SetFadeSpeed( 0.5 );
mainWindow:SetVisible( true );

LoadSettings();

mainWindow:SetPosition(settings.positionX, settings.positionY);

-- Old mainWindow:SetPosition
--[[local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
local windowWidth, windowHeight = mainWindow:GetSize();
mainWindow:SetPosition((displayWidth-windowWidth)/2,(displayHeight - windowHeight)/2);]]

leftWindow = Turbine.UI.Extensions.SimpleWindow();
leftWindow:SetSize( 35 , 35 );
leftWindow:SetParent( mainWindow );
leftWindow:SetPosition( 47.5, 50 );
leftWindow:SetOpacity( 0.25 );
leftWindow:SetFadeSpeed( 0.5 );
leftWindow:SetVisible( true );

centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 35 , 35 );
centerWindow:SetParent( mainWindow );
centerWindow:SetPosition( 82.5, 40 );
centerWindow:SetVisible( true );

rightWindow = Turbine.UI.Extensions.SimpleWindow();
rightWindow:SetSize( 35 , 35 );
rightWindow:SetParent( mainWindow );
rightWindow:SetPosition( 117.5, 50 );
rightWindow:SetOpacity( 0.25 );
rightWindow:SetFadeSpeed( 0.5 );
rightWindow:SetVisible( true );

releaseWindow = Turbine.UI.Extensions.SimpleWindow();
releaseWindow:SetSize( 14, 14 );
releaseWindow:SetParent( mainWindow );
releaseWindow:SetPosition( 94, 77 );
releaseWindow:SetOpacity( 0.25 );
releaseWindow:SetFadeSpeed( 0.5 );
releaseWindow:SetVisible( true );

-- Old releaseButton
--[[releaseButton = Turbine.UI.Button()
releaseButton:SetParent( releaseWindow );
releaseButton:SetText("X");
releaseButton:SetSize( 14, 14 );
releaseButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
releaseButton:SetForeColor( Turbine.UI.Color( 1, 0, 0 ) );
releaseButton:SetVisible( true );]] 

releaseButtonLabel = Turbine.UI.Label();
releaseButtonLabel:SetParent(releaseWindow);
releaseButtonLabel:SetSize( 14, 14 );
releaseButtonLabel:SetBackground( "PaulinoPlugins/PetCarousel/Resources/x.tga" );
releaseButtonLabel:SetMouseVisible(false);

releaseQSBack = Turbine.UI.Control();
releaseQSBack:SetParent( releaseWindow );
releaseQSBack:SetZOrder(-1);

releaseQS = Turbine.UI.Lotro.Quickslot();
releaseQS:SetParent(  releaseQSBack );
releaseQS:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/pet releaseall"));
releaseQS:SetSize( 14, 14 );
releaseQS:SetAllowDrop(false);

petData = { };

-- Pet Carousel: Adds your own codes here, that's all!

petData[0] = "0x70003EB5"; --Raven
petData[1] = "0x70024A63"; --Blood Raven
petData[2] = "0x70024A60"; --Mottledwing Raven
petData[3] = "0x70024A62"; --Frost Raven
petData[4] = "0x70024A5F"; --Storm Raven
petData[5] = "0x70024A5D"; --Weathered Raven
petData[6] = "0x70003EB8"; --Friend of Bears (Bear)
petData[7] = "0x70024A6E"; --Black Bear
petData[8] = "0x70024A6C"; --Polar Bear
petData[9] = "0x70024A65"; --Wildpaw Bear
petData[10] = "0x70024A69"; --Tundra Bear Cub
petData[11] = "0x70024A68"; --Blackpaw Bear
petData[12] = "0x70024A66"; --Weathered Bear
petData[13] = "0x7000B8D3"; --Lynxspeech (Lynx)
petData[14] = "0x70024A73"; --Spotted Lynx
petData[15] = "0x70024A7A"; --Onyx Lynx
petData[16] = "0x70024A74"; --Tundra Lynx
petData[17] = "0x70024A75"; --Grey Lynx
petData[18] = "0x70024A79"; --Mountain Lynx
petData[19] = "0x70000FB2"; --Eaglefriend (Eagle)
petData[20] = "0x70024A7E"; --Ashen Eagle
petData[21] = "0x70024A80"; --Snowcrest Eagle
petData[22] = "0x70024A84"; --Ember Eagle
petData[23] = "0x70024A82"; --Tundra Eagle
petData[24] = "0x7000F530"; --Friend of Feline Hunters (Saber Tooth)
petData[25] = "0x70024A8D"; --Dusky Sabercat
petData[26] = "0x70024A89"; --Spotted Sabercat
petData[27] = "0x70024A8F"; --Grey Sabercat
petData[28] = "0x70024A8B"; --Deepwood Sabercat
petData[29] = "0x70024A8A"; --Striped Sabercat
petData[30] = "0x70024A87"; --Onyx Sabercat
petData[31] = "0x7000F54D"; --Naturefriend (Bog Guardian)
petData[32] = "0x70024A93"; --Swamp Guardian
petData[33] = "0x70024A95"; --Mountain Guardian
petData[34] = "0x70024A91"; --Tundra Guardian
petData[35] = "0x7002A706"; -- Spirit of Nature
petData[36] = "0x7002CFE5"; -- Spirit Boar
petData[37] = "0x7002CFE6"; -- Spirit Lynx
petData[38] = "0x7002CFE7"; -- Spirit Bear
petData[39] = "0x7002CFE8"; -- Spirit Sabre Cat
petData[39] = "0x7002CFE9"; -- Spirit Aurochs
petData[39] = "0x7002CFEA"; -- Spirit Raven
petData[39] = "0x7002CFEB"; -- Spirit Cub

petQS = { };

for i = 0, TableCount(petData)-1 do

	petQS[i] = Turbine.UI.Lotro.Quickslot();
	petQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, petData[i] ) );

end

cosmeticPetData = { }; 

-- Cosmetic Pet Carousel: Adds your own codes here, that's all!

cosmeticPetData[0] = "0x7000BF8E"; -- Turtle
cosmeticPetData[1] = "0x7000BF72"; -- Bird
cosmeticPetData[2] = "0x7000BF73"; -- Cat
cosmeticPetData[3] = "0x7000BF74"; -- Dog
cosmeticPetData[4] = "0x7000BF75"; -- Fox
cosmeticPetData[5] = "0x7000BF76"; -- Frog
cosmeticPetData[6] = "0x7000BF77"; -- Rabbit
cosmeticPetData[7] = "0x7000BF78"; -- Snake
cosmeticPetData[8] = "0x7000BF79"; -- Squirrel

cosmeticPetQS = { };

for i = 0, TableCount(cosmeticPetData)-1 do

	cosmeticPetQS[i] = Turbine.UI.Lotro.Quickslot();
	cosmeticPetQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, cosmeticPetData[i] ) );

end

customPetQS = { };

for i = 0, TableCount(settings.customShortcuts)-1 do
	
	customPetQS[i] = Turbine.UI.Lotro.Quickslot();
	customPetQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.customShortcuts[i].Type, settings.customShortcuts[i].Data ) );

end

leftLabel = Turbine.UI.Label();
leftLabel:SetParent(leftWindow);
leftLabel:SetPosition( 0, 0 );
leftLabel:SetSize( 37.5, 41  );
leftLabel:SetText( "" );
leftLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
leftLabel:SetZOrder(-1);
leftLabel:SetMouseVisible(false);

leftQS = Turbine.UI.Lotro.Quickslot();
leftQS:SetParent( leftWindow );
leftQS:SetPosition( 0, 0 );
leftQS:SetSize( 35, 35 );
leftQS:SetUseOnRightClick(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 37.5, 41  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS = Turbine.UI.Lotro.Quickslot();
centerQS:SetParent( centerWindow );
centerQS:SetPosition( 0, 0 );
centerQS:SetSize( 35, 35 );
centerQS:SetUseOnRightClick(false);

rightLabel = Turbine.UI.Label();
rightLabel:SetParent(rightWindow);
rightLabel:SetPosition( 0, 0 );
rightLabel:SetSize( 37.5, 41  );
rightLabel:SetText( "" );
rightLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
rightLabel:SetZOrder(-1);
rightLabel:SetMouseVisible(false);

rightQS = Turbine.UI.Lotro.Quickslot();
rightQS:SetParent( rightWindow );
rightQS:SetPosition( 0, 0 );
rightQS:SetSize( 35, 35 );
rightQS:SetUseOnRightClick(false);

petQS1 = settings.petQS1;
petQS2 = settings.petQS2;
petQS3 = settings.petQS3;
cosmeticQS1 = settings.cosmeticQS1;
cosmeticQS2 = settings.cosmeticQS2;
cosmeticQS3 = settings.cosmeticQS3;
customQS1 = settings.customQS1;
customQS2 = settings.customQS2;
customQS3 = settings.customQS3;

activeCarousel = settings.activeCarousel;

function LoadShortcuts()

	if (activeCarousel == 0) then		
		
		leftQS:SetShortcut(petQS[petQS1]:GetShortcut());
		leftQS:SetAllowDrop(false);
		centerQS:SetShortcut(petQS[petQS2]:GetShortcut());
		centerQS:SetAllowDrop(false);
		rightQS:SetShortcut(petQS[petQS3]:GetShortcut());
		rightQS:SetAllowDrop(false);

	elseif (activeCarousel == 1) then

		leftQS:SetShortcut(cosmeticPetQS[cosmeticQS1]:GetShortcut());
		leftQS:SetAllowDrop(false);
		centerQS:SetShortcut(cosmeticPetQS[cosmeticQS2]:GetShortcut());
		centerQS:SetAllowDrop(false);
		rightQS:SetShortcut(cosmeticPetQS[cosmeticQS3]:GetShortcut());
		rightQS:SetAllowDrop(false);

	elseif (activeCarousel == 2) then
	
		leftLabel:SetText(tostring(customQS1+1));
		leftQS:SetShortcut(customPetQS[customQS1]:GetShortcut());
		leftQS:SetAllowDrop(true);
		centerLabel:SetText(tostring(customQS2+1));
		centerQS:SetShortcut(customPetQS[customQS2]:GetShortcut());
		centerQS:SetAllowDrop(true);
		rightLabel:SetText(tostring(customQS3+1));
		rightQS:SetShortcut(customPetQS[customQS3]:GetShortcut());
		rightQS:SetAllowDrop(true);
		
	end

end

LoadShortcuts();

if ( settings.welcome == false ) then
	Turbine.Shell.WriteLine(" *** Welcome to the Pet Carousel! ***\n - To show the help type /pc help");
end

PetCarouselCommand = Turbine.ShellCommand();

function PetCarouselCommand:Execute( command, arguments )

	if ( arguments == "help" ) then
		Turbine.Shell.WriteLine(" *** Pet Carousel Help ***\n\n - Use the Mouse Wheel over any Shortcut to move the Carousel.\n - Right click the middle Shortcut to change to the Cosmetic Pet Carousel or the Custom Carousel.\n - Click the red cross to release your pet.\n - Right click anywhere in the window to hide it.\n - Use the command '/pc' or '/petcarousel' to hide or show the Plugin.\n - Use the command '/pc restore' to move the window to its default position.\n - Use the command '/pc welcomeoff' to turn off the welcome message.\n - Use the command '/pc welcomeon' to turn on the welcome message.");
	elseif ( arguments == "welcomeoff" ) then
		settings.welcome = true;
		SaveSettings();
		Turbine.Shell.WriteLine("Welcome message has been disabled");
	elseif (arguments == "welcomeon" ) then
		settings.welcome = false;
		SaveSettings();
		Turbine.Shell.WriteLine("Welcome message has been enabled");
	elseif ( arguments == "restore" ) then
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
		mainWindow:SetPosition(settings.positionX, settings.positionY);
		SaveSettings();
		Turbine.Shell.WriteLine("Window restored to its default position");
	elseif ( arguments ~= nil ) then
		mainWindow:SetVisible( not mainWindow:IsVisible() );
	end

end

Turbine.Shell.AddCommand( "pc;petcarousel", PetCarouselCommand );

mainWindow.MouseEnter = function( sender, args )

	if (alwaysHide == false) then
		mainWindow:SetOpacity( 0.75 );
	end

	rightWindow:SetOpacity( 0.75 );
	leftWindow:SetOpacity( 0.75 );
	releaseWindow:SetOpacity( 0.75 );

end

mainWindow.MouseLeave = function( sender, args )

	local X, Y = mainWindow:GetPosition();

	if (alwaysHide == false) then
		mainWindow:SetOpacity( 0 );
	end

	rightWindow:SetOpacity( 0.25 );
	leftWindow:SetOpacity( 0.25 );
	releaseWindow:SetOpacity( 0.25 );

	if ( X ~= settings.positionX or Y ~= settings.positionY ) then
			
		settings.positionX = X;
		settings.positionY = Y;
		SaveSettings();
			
	end

end

-- Old releaseButton events
--[[releaseButton.MouseUp = function( sender, args)

	releaseButton:SetOutlineColor( Turbine.UI.Color( 1, 1, 1 ) );

end

releaseButton.MouseDown = function( sender, args)

	releaseButton:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );

end


releaseButton.MouseEnter = function( sender, args)

	releaseButton:SetOutlineColor( Turbine.UI.Color( 1, 1, 1 ) );

end

releaseButton.MouseLeave = function( sender, args)

	releaseButton:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );

end

releaseButton.MouseClick = function( sender, args)

	Turbine.Shell.Execute( "/pet releaseall" );
	Turbine.Shell.WriteLine( "Pet released" );

end]]

releaseQS.MouseEnter = function (sender, args)

	releaseButtonLabel:SetBackground( "PaulinoPlugins/PetCarousel/Resources/x_glow.tga" );

end

releaseQS.MouseLeave = function (sender, args)

	releaseButtonLabel:SetBackground( "PaulinoPlugins/PetCarousel/Resources/x.tga" );

end

alwaysHide = settings.alwaysHide;

mainWindow.MouseClick = function (sender, args)

	if ( args.Button == Turbine.UI.MouseButton.Right ) then

		if (alwaysHide == false ) then
			mainWindow:SetOpacity ( 0 );
			alwaysHide = true;
		else
			mainWindow:SetOpacity( 0.75 );
			alwaysHide = false;
		end
		
		settings.alwaysHide = alwaysHide;
		SaveSettings();

	end

end

drag = false;

leftQS.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

leftQS.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS1);

end

leftQS.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS1);
	
end

leftQS.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

centerQS.MouseClick = function (sender, args)

	if ( args.Button == Turbine.UI.MouseButton.Right ) then
		
		if (activeCarousel == 0) then

			activeCarousel = 1;
			LoadShortcuts();

		elseif (activeCarousel == 1) then
		
			activeCarousel = 2;
			LoadShortcuts();
		
		elseif (activeCarousel == 2) then

			activeCarousel = 0;
			LoadShortcuts();

		end
		
		settings.activeCarousel = activeCarousel;
		
		SaveSettings();

	end

end

centerQS.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

centerQS.MouseLeave = function(sender, args)

	CheckChanges();

end

centerQS.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS2);

end

centerQS.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS2);
	
end

centerQS.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

rightQS.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

rightQS.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS3);

end

rightQS.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS3);
	
end

rightQS.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

function ChangeShortcut(qs, qsPosition)

	if ((activeCarousel == 2) and (qs:GetShortcut():GetData() ~= settings.customShortcuts[qsPosition].Data)) then

		settings.customShortcuts[qsPosition].Type = qs:GetShortcut():GetType();
		settings.customShortcuts[qsPosition].Data = qs:GetShortcut():GetData();
		customPetQS[qsPosition]:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.customShortcuts[qsPosition].Type, settings.customShortcuts[qsPosition].Data ) );
		SaveSettings();
	
	end

end

function RemoveShortcut(qs, qsPosition)

	if (drag) then
	
		if (activeCarousel == 2) then

			settings.customShortcuts[qsPosition].Type = "nil";
			settings.customShortcuts[qsPosition].Data = "";
			customPetQS[qsPosition]:SetShortcut( Turbine.UI.Lotro.Shortcut( nil, "" ) );
			qs:SetShortcut(customPetQS[qsPosition]:GetShortcut());
			qs:SetAllowDrop(true);
			SaveSettings();
			drag = false;
			
		end
		
	end

end

function Carousel(modifier) -- And yet it moves!

	if (activeCarousel == 0) then

		local total = TableCount(petData);
	
		petQS1 = (petQS1 + modifier) % total;
		petQS2 = (petQS2 + modifier) % total;
		petQS3 = (petQS3 + modifier) % total;

		LoadShortcuts();

	elseif (activeCarousel == 1) then

		local total = TableCount(cosmeticPetData);
	
		cosmeticQS1 = (cosmeticQS1 + modifier) % total;
		cosmeticQS2 = (cosmeticQS2 + modifier) % total;
		cosmeticQS3 = (cosmeticQS3 + modifier) % total;

		LoadShortcuts();
	
	elseif (activeCarousel == 2) then
		
		local total = TableCount(settings.customShortcuts);
		
		customQS1 = (customQS1 + modifier) % total;
		customQS2 = (customQS2 + modifier) % total;
		customQS3 = (customQS3 + modifier) % total;
	
		LoadShortcuts();
	
	end

end

function CheckChanges()

	if (activeCarousel == 0) and (settings.petQS1 ~= petQS1) then
	
		settings.petQS1 = petQS1;
		settings.petQS2 = petQS2;
		settings.petQS3 = petQS3;
	
	elseif (activeCarousel == 1) and (settings.cosmeticQS1 ~= cosmeticQS1) then
	
		settings.cosmeticQS1 = cosmeticQS1;
		settings.cosmeticQS2 = cosmeticQS2;
		settings.cosmeticQS3 = cosmeticQS3;
	
	elseif (activeCarousel == 2) and (settings.customQS1 ~= customQS1) then
	
		settings.customQS1 = customQS1;
		settings.customQS2 = customQS2;
		settings.customQS3 = customQS3;
	
	end

	SaveSettings();

end